#include <stdint.h>    
#include <Arduino.h>  
#include <WiFiClient.h>
// Основные настройки проекта
#define ENABLE_OLED_DISPLAY    // Раскомментируйте для использования дисплея
#define ENABLE_OTA             // OTA-обновление
#define ENABLE_WIFI            // Работа с WiFi
#define ENABLE_WEB_SERVER      // Веб-сервер
#define ENABLE_USART_SAMOVAR   // Управление по USART
#define ENABLE_ZEROCROSS       // Детектор нуля
//#define PZEM_FILTR             // Фильтр измерений мощности (если скачет)
//#define ENABLE_MQTT            // Управление через MQTT
// Выбирать одно из трех:
//#define ENABLE_TRIAC           // Использовать управление симистором
#define ENABLE_SSR40DA           // Использовать управление SSR-40DA  
//#define ENABLE_SSR40LA           // Использовать управление SSR-40LA 

#define PMAX_TEN 0          // Максимальная мощность ТЭНа исходная

// Константы для пинов
#define boostPin 16            // Реле разгона
#define heatPin 14             // Реле ТЭНов
#define zeroCrossPin 12        // Детектор нуля
#define triacPin 15            // Симистор или твердотельное реле
#define BUTTON_PIN 13          // Кнопка 
#define PZEM_RX_PIN 0          // RX, пины для software serial PZEM-004T
#define PZEM_TX_PIN 2          // TX 
// 4 и 5 I2C. Свободные пины: A0 (0-1В)

// Настройки WiFi
#define defaultSSID "" // Ссид и пароль по умолчанию, позволяет использовать два набора, первый можно сохранить в EEPROM 
#define defaultPass "" // через WEB интерфейс, это второй по ходу загрузки
#define EEPROM_SIZE 512
#define SSID_ADDR 0
#define PASS_ADDR 32

// Настройки MQTT
#define mqtt_server "mqtt.broker.com"
#define mqtt_port 1883
#define mqtt_user "username"
#define mqtt_password "password"

// Объявления глобальных переменных
extern float voltage;
extern float current;
extern uint16_t power;
extern float energy;
extern int16_t powerSetpoint, powerSetpointT;
extern uint16_t maxPower;
extern bool heatEnabled;
extern bool PzemEnClear;
extern bool insufficientVoltage;
extern volatile bool boostMode;                // Флаг режима разгона
extern bool heatEnabled;
extern bool heatEnabledBoost;
extern bool boostLoadActive;  
extern unsigned long boostLoadStartTime;  
extern uint16_t boostLoadMaxPower;
extern unsigned long responseDelay;  
extern unsigned long lastRequestTime; 
extern String pendingResponse;  
extern volatile bool zeroCrossDetected;
extern volatile unsigned long zeroCrossTime;
extern volatile bool timer1flag; 
//extern unsigned long delayTime; 
///extern bool triacTriggered;
//extern unsigned long triacTurnOffTime;
extern volatile int16_t PowerLevel;
extern String savedSSID;
extern String savedPass;
extern bool hotspotMode;
extern volatile const int16_t MaxPowerLevel; 

#if defined(ENABLE_WEB_SERVER) || defined(ENABLE_MQTT) || defined(ENABLE_OTA)
#define ENABLE_WIFI 
#endif
#ifdef ENABLE_SSR40DA
#undef ENABLE_TRIAC
#undef ENABLE_SSR40LA
#endif
#ifdef ENABLE_TRIAC
#undef ENABLE_SSR40LA
#endif