//Модуль написан, но еще не проверен
#include "mqtt_control.h"
#include <Arduino.h> 
#include "Stab_config.h"
#ifdef ENABLE_MQTT  
// Топики MQTT
const char* mqtt_topic_power = "stab/power/set"; // Топик для установки мощности
const char* mqtt_topic_boost = "stab/boost/set"; // Топик для включения/выключения режима разгона
const char* mqtt_topic_heat = "stab/heat/set";   // Топик для включения/выключения нагрева
const char* mqtt_topic_status = "stab/status";   // Топик для публикации статуса

WiFiClient espClient;
PubSubClient mqttClient(espClient);
#endif 
// Функция для обработки входящих MQTT сообщений
void mqttCallback(char* topic, byte* payload, unsigned int length) {
  #ifdef ENABLE_MQTT
  String message;
  for (int i = 0; i < length; i++) {
    message += (char)payload[i];
  }

  // Управление только при активном подключении
  if (mqttClient.connected()) {
    if (String(topic) == mqtt_topic_power) {
      // Установка мощности
      uint16_t newPower = message.toInt();
      if (newPower >= 0 && newPower <= 10000) {
        powerSetpoint = newPower;
        mqttClient.publish(mqtt_topic_status, ("Power set to: " + String(powerSetpoint)).c_str());
      }
    } else if (String(topic) == mqtt_topic_boost) {
      // Включение/выключение режима разгона
      if (message == "1") {
        boostMode = true;
        digitalWrite(boostPin, HIGH);
        mqttClient.publish(mqtt_topic_status, "Boost mode enabled");
      } else if (message == "0") {
        boostMode = false;
        digitalWrite(boostPin, LOW);
        mqttClient.publish(mqtt_topic_status, "Boost mode disabled");
      }
   } else if (String(topic) == mqtt_topic_heat) {
    // Включение/выключение нагрева
    if (message == "1") {
      heatEnabled = true;
      digitalWrite(heatPin, HIGH);
      mqttClient.publish(mqtt_topic_status, "Heat enabled");
    } else if (message == "0") {
      heatEnabled = false;
      digitalWrite(heatPin, LOW);
      mqttClient.publish(mqtt_topic_status, "Heat disabled");
    }
  }
}
#endif 
}

// Функция для подключения к MQTT-брокеру с 1 попытками
void mqttConnect() {
  #ifdef ENABLE_MQTT
  int attempts = 0;
  while (!mqttClient.connected() && attempts < 1) {
    Serial.print("Attempting MQTT connection...");
    if (mqttClient.connect("ESP12E_Stabilizer", mqtt_user, mqtt_password)) {
      Serial.println("connected");
      mqttClient.subscribe(mqtt_topic_power);
      mqttClient.subscribe(mqtt_topic_boost);
      mqttClient.subscribe(mqtt_topic_heat);
    } else {
      Serial.print("failed, rc=");
      Serial.print(mqttClient.state());
      Serial.println(" try again in 5 seconds");
      delay(5000);
      attempts++;
    }
  }
  if (attempts >= 5) {
    Serial.println("Failed to connect to MQTT broker after 1 attempts.");
  }
  #endif 
}

// Инициализация MQTT
void setupMQTT() {
  #ifdef ENABLE_MQTT
  mqttClient.setServer(mqtt_server, mqtt_port);
  mqttClient.setCallback(mqttCallback);
  mqttConnect();
  #endif 
}

// Обновление MQTT в основном цикле
void loopMQTT() {
  #ifdef ENABLE_MQTT
  /*if (!mqttClient.connected()) {
    mqttConnect();
  }*/
  mqttClient.loop();

  // Публикация текущего статуса только при активном подключении
  if (mqttClient.connected()) {
    static unsigned long lastStatusUpdate = 0;
    if (millis() - lastStatusUpdate > 10000) { // Публикуем статус каждые 10 секунд
      String status = "Voltage: " + String(voltage) + " V, Current: " + String(current) + " A, Power: " + String(power) + " W, Energy: " + String(energy) + " kWh";
      mqttClient.publish(mqtt_topic_status, status.c_str());
      lastStatusUpdate = millis();
    }
  }
  #endif 
}
