 #include "PZEM.h"
 #include "Stab_config.h"
 #include "wifi_utils.h"
 #include "zero_cross.h"
 #include "mqtt_control.h"
 #include "usart_samovar.h"
 #include "web_server.h"
 #include "oled_display.h"
 #include "mqtt_control.h"
 #include "OTA.h"

float voltage, current,  energy;        // Измеряемые значения
uint16_t power;                         // Мощность текущая и целевая
int16_t powerSetpoint = 0, powerSetpointT;      
uint16_t maxPower = PMAX_TEN;           // максимально достигнутая
volatile int16_t  PowerLevel = 0;                // Текущий уровень регулировки 0-1023
volatile const int16_t  MaxPowerLevel = 1023;          // Максимальный уровень регулировки

bool PzemEnClear = false;              // Флаг команды на обнуление счетчика
bool insufficientVoltage = false;      // Флаг недостаточного напряжения

bool heatEnabled = false;
bool boostLoadActive = false;          // Флаг для блокировки регулировки на время прогрузки
unsigned long boostLoadStartTime = 0;  // Время начала прогрузки
uint16_t boostLoadMaxPower = 0;        // Максимальная мощность, зафиксированная во время прогрузки

//...........................................................................................................



// Запуск...
void setup() {
  initOLED();                    // Инициализация дисплея
  InitButtons();                 // Инициализация кнопок
  Serial.begin(9600);
  PZEMInit();                   // Инициализация измерений
  Serial.println(); Serial.println("Start...");
                                // Инициализация пинов 
   pinMode(boostPin, OUTPUT);  digitalWrite(boostPin, LOW);
   pinMode(heatPin, OUTPUT);   digitalWrite(heatPin, LOW);
   initWiFi();                  // Загрузка сохраненных данных и  запуск Wi-Fi
   setupWebServer();            // Запуск веб-сервера
   initOTA();                   // Запуск ОТА
   setupMQTT();                 // запуск MQTT
   StaticOLEDDisplay();         // Выводим на дисплей статические названия полей
   zeroCrossInit();             //Инициализация датчика пересечения с 0
}
//Основной цикл
void loop() { 
    #ifdef ENABLE_OTA // Обработка ОТА
    MDNS.update(); ArduinoOTA.handle();
    #endif
    #ifdef ENABLE_USART_SAMOVAR
    USART_GetRequests();        //Принимаем по UART запросы от Самовара
    USART_SendReport();         // Отправляем ответ Самовару по UART с необходимой задержкой
    #endif //ENABLE_USART_SAMOVAR 
    #ifdef ENABLE_MQTT
     loopMQTT();                // Обработка MQTT
    #endif                      //ENABLE_MQTT
     ButtonsLoop();             // Обработка кнопок

  static unsigned long timeout = millis(); //остальное раз в секунду
  if (millis() - timeout >= 1000) { 
    #ifdef ENABLE_WEB_SERVER
     if (boostLoadActive) TEN_Boost();     // если надо прогружаем ТЭН
     //установка флага невозможности выполнить задачу по мощности
     insufficientVoltage = (powerSetpoint > maxPower && PowerLevel == MaxPowerLevel);
    #endif // ENABLE_WEB_SERVER
    PZEMLoop();                             //Читаем параметры электросети
    triakLoop();                           // Обработка симистора
    #ifdef ENABLE_OLED_DISPLAY  
    updateOLEDDisplay();                   //Выводим инфу на дисплей
    #endif
    timeout = millis();                    //перезапуск секундного таймера
  }    
}