#include <ESP8266WiFi.h>
#include <EEPROM.h> 
#include "Stab_config.h" // Подключаем объявления переменных

 String savedSSID, savedPass;
 bool hotspotMode = false;
#ifdef ENABLE_WIFI  
// Функция для сохранения данных в EEPROM

void writeEEPROM(int addr, String data) {
  for (int i = 0; i < data.length() && i < 31; i++) {
    EEPROM.write(addr + i, data[i]);
  }
  EEPROM.write(addr + data.length(), 0); // Записываем нулевой байт в конце 
}
// Функция для чтения данных из EEPROM
String readEEPROM(int addr) {
  String data;
  char ch;
  while (ch = EEPROM.read(addr++)) {
    data += ch;
  }
  return data;
}
// Старт точки доступа
void startHotspot() {
  hotspotMode = true;
  WiFi.softAP("PoverStabiliser", "12345678");
  Serial.println("Hotspot started. IP: " + WiFi.softAPIP().toString());
}

 void ConnectWIFI(String SSID, String Pass){
   WiFi.begin(SSID, Pass);
   Serial.print("Connecting to WiFi "); 
   Serial.println(SSID); //Serial.println(savedPass);
    uint32_t startTime = millis();
    while (WiFi.status() != WL_CONNECTED && millis() - startTime < 10000) {
      Serial.print(".");
      delay(200);
    } 
    Serial.println();
  }

void WiFiSetup(String savedSSID, String savedPass){
 hotspotMode = false;
 EEPROM.begin(EEPROM_SIZE);
 writeEEPROM(SSID_ADDR, savedSSID);
 writeEEPROM(PASS_ADDR, savedPass);
 EEPROM.commit();
 ConnectWIFI(savedSSID, savedPass);
}
void hotspotSetup(){
 Serial.println("Starting hotspot...");  // Отладочный вывод
 hotspotMode = true;
 EEPROM.begin(EEPROM_SIZE);
 writeEEPROM(SSID_ADDR, "");
 writeEEPROM(PASS_ADDR, "");
 EEPROM.commit();
 startHotspot();
}

// Инициализация Wifi
void initWiFi() {
   EEPROM.begin(EEPROM_SIZE);
   savedSSID = readEEPROM(SSID_ADDR);
   savedPass = readEEPROM(PASS_ADDR);
   if (savedSSID.length() != 0) ConnectWIFI(savedSSID, savedPass);
   if (WiFi.status() != WL_CONNECTED && defaultSSID != "") ConnectWIFI(defaultSSID, defaultPass);

    if (WiFi.status() != WL_CONNECTED) {
      Serial.println("Failed to connect to WiFi. Starting hotspot...");
      startHotspot();
    } else {
      Serial.println();
      Serial.print("Connected to WiFi. IP: ");
      Serial.println(WiFi.localIP());
      Serial.print("Signal Strength (RSSI): ");
      Serial.print(WiFi.RSSI()); Serial.println(" dBm");
    }
}
#endif // WIFI
